﻿@model FSAReportViewModel

@{
    ViewBag.IsRegistrantReport = true;

    bool showResult = Request.QueryString["year"] != null || Request.QueryString["filterType"] != null || Request.QueryString["startDate"] != null || Request.QueryString["endDate"] != null || Model.Year.HasValue || Model.StartDate.HasValue || Model.EndDate.HasValue;
}

<div class="container">

    <div class="row">
        <div class="col-md-12">
            <div class="title-page">
                <h1>
                    Dependent care receipt
                </h1>
            </div>
            <div class="wrapper">
                <div id="wrapper-title">
                    <span>
                        Report search criteria
                    </span>
                </div>
                <div class="wrapper-content container-fluid">
                    @using (Html.BeginForm("FSAReport", "Registrant", FormMethod.Get))
                    {
                        <div class="row">
                            <div class="col-md-4">
                                <div class="head-choose-filter">
                                    <div class="radio-inline">
                                        <label>
                                            @Html.RadioButtonFor(model => model.FilterType, FSAReportFilterType.Year)
                                            Year
                                        </label>
                                    </div>
                                </div>
                                <div class="content-choose-filter">
                                    @Html.DropDownListFor(model => model.Year, (List<SelectListItem>)ViewBag.Years, new { @class = "form-control report-dropdown" })
                                </div>
                            </div>
                            <div class="col-md-8">
                                <div class="head-choose-filter">
                                    <div class="radio-inline">
                                        <label>
                                            @Html.RadioButtonFor(model => model.FilterType, FSAReportFilterType.DateRange)
                                            Payment date
                                        </label>
                                    </div>
                                </div>
                                <div class="content-choose-filter">
                                    @(Html.Kendo().DatePickerFor(s => s.StartDate)
                                                        .Name("StartDate")
                                                        .HtmlAttributes(new { type = "text", @class = "form-control txt-group-filter" })
                                    )
                                    to
                                    @(Html.Kendo().DatePickerFor(s => s.EndDate)
                                                   .Name("EndDate")
                                                   .HtmlAttributes(new { type = "text", @class = "form-control txt-group-filter" })
                                    )
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-md-12">
                                <button type="submit" class="btn btn_side-right-bottom btn_color-green">View Report</button>
                            </div>
                        </div>
                    }
                </div>
            </div>
        </div>
    </div>

    <div class="row">
        <div class="col-md-12 result-report">

            @if (showResult)
            {
                <div class="title-result-report">

                    <a id="downloadExport" href="" class="btn-report-download">
                        Download
                    </a>
                    <select id="selectExport" class="select-export">
                        <option>PDF</option>
                        <option>Excel</option>
                    </select>
                    <a id="print" class="button btn-report-print">
                        <i class="jbi-print"></i>
                    </a>
                </div>
                <div class="content-result">
                    <div class="div2" id="fsaReportGrid">
                    </div>
                </div>
                <div id="window"></div>
            }
        </div>
        <div class="clearfix"></div>
    </div>

</div>


<script src="~/Scripts/Libraries/KendoUI/kendo.all.min.js"></script>
<script src="~/Scripts/jquery-ui-1.9.0.min.js"></script>
<script src="~/Scripts/Libraries/KendoUI/jszip.min.js"></script>
<script src="~/Scripts/Libraries/KendoUI/pako_deflate.min.js"></script>


<style>
    .k-grid tr {
        background-color: #fff;
    }

    .page-template .footer {
        position: absolute;
        bottom: 30px;
        left: 30px;
        right: 30px;
        border-top: 1px solid #888;
        text-align: center;
        color: #888;
    }
</style>

<script id="toolbarTemplate" type="text/x-kendo-template">
    <div>
        @for (int i = 0; i < ViewBag.Count; i++)
        {
            <ul class="ul-partner-info">
                @if (i == 0)
                {
                    <li id="classMeetingDates">Class meeting dates (@ViewBag.Date)</li>
                }
                <li id="name">@ViewBag.Header[i].Name</li>
                @*<li>@ViewBag.PartnerP_O_Box</li>*@
                <li id="address">@ViewBag.Header[i].Address</li>
                <li id="phone">@ViewBag.Header[i].Phone</li>
                <li id="site">@ViewBag.Header[i].Site</li>
                <li id="email">@ViewBag.Header[i].Email</li>
                @*<li>fax:@ViewBag.PartnerFax</li>*@
                <li></li>
            </ul>
        }
    </div>
</script>



<script>

    function printGrid() {
        var gridElement = $('#fsaReportGrid'),
            printableContent = '',
            win = window.open('', '', 'width=800, height=500, resizable=1, scrollbars=1'),
            doc = win.document.open();

        var htmlStart =
                 '<!DOCTYPE html>' +
                 '<html>' +
                 '<head>' +
                 '<meta charset="utf-8" />' +
                '<title></title>' +
                 '<div>@for(int i = 0; i< ViewBag.Count; i++){ <ul style="list-style:none"> @if (i == 0) { <li> Class meeting dates (@ViewBag.Date)</li> }' +
                 '<li>@ViewBag.Header[i].Name</li>' +
                 @*'<li>@ViewBag.PartnerP_O_Box</li>' +*@
                 '<li>@ViewBag.Header[i].Address</li>' +
                 '<li>@ViewBag.Header[i].Phone</li>' +
                 '<li>@ViewBag.Header[i].Site</li>' +
                 '<li>@ViewBag.Header[i].Email</li>' +
                 @*'<li>fax:@ViewBag.PartnerFax</li>' +*@
                 '</ul> }</div>' +
                 '<link href="http://kendo.cdn.telerik.com/' + kendo.version + '/styles/kendo.common.min.css" rel="stylesheet" /> ' +
                 '<style>' +
                 'html { font: 11pt sans-serif; text-align: left }' +
                 '.k-grid { border-top-width: 0; }' +
                 '.k-grid, .k-grid-content { height: auto !important; padding: 20px; text-align: left}' +
                 '.k-grid-content { overflow: visible !important; padding: 20px;}' +
                 '.k-grid .k-grid-header  th { border-top: 1px solid; padding-bottom: 20px }' +
                 '.k-grid-toolbar, .k-grid-pager > .k-link { display: none; }' +
                 '</style>' +
                 '</head>' +
                 '<body>';

        var htmlEnd =
                '</body>' +
                '</html>';

        var gridHeader = gridElement.children('.k-grid-header');
        if (gridHeader[0]) {
            var thead = gridHeader.find('thead').clone().addClass('k-grid-header');
            printableContent = gridElement
                .clone()
                    .children('.k-grid-header').remove()
                .end()
                    .children('.k-grid-content')
                        .find('table')
                            .first()
                                .children('tbody').before(thead)
                            .end()
                        .end()
                    .end()
                .end()[0].outerHTML;
        } else {
            printableContent = gridElement.clone()[0].outerHTML;
        }

        doc.write(htmlStart + printableContent + htmlEnd);
        doc.close();
        win.print();

    }


    function startChange() {
        var endPicker = $("#StartDate").data("kendoDatePicker"),
            startDate = this.value();

        if (startDate) {
            startDate = new Date(startDate);
            startDate.setDate(startDate.getDate() + 1);
            endPicker.min(startDate);
        }
    }


    function displayLoading(target, status) {
        var element = $(target);
        kendo.ui.progress(element, status);
    }


    $('document').ready(function () {


        if ($('input[name=FilterType]:checked').val() == "Year") {
            $('#StartDate').attr("disabled", true);
            $('#EndDate').attr("disabled", true);
            $('#Year').attr("disabled", false);
        } else if ($('input[name=FilterType]:checked').val() == "DateRange") {
            $('#Year').attr("disabled", true);
            $('#StartDate').attr("disabled", false);
            $('#EndDate').attr("disabled", false);
        }




        $('input[name=FilterType]').click(function () {

            if ($('input[name=FilterType]:checked').val() == "Year") {
                $('#StartDate').attr("disabled", true);
                $('#EndDate').attr("disabled", true);
                $('#Year').attr("disabled", false);
            } else if ($('input[name=FilterType]:checked').val() == "DateRange") {
                $('#Year').attr("disabled", true);
                $('#StartDate').attr("disabled", false);
                $('#EndDate').attr("disabled", false);
            }
        });



        @if (showResult)
          {
              <text>
        var initialLoad = true;

        $("#fsaReportGrid").kendoGrid({
            dataSource: {
                type: "json",
                transport: {
                    read: {
                        url: "GetFSAReport?filterType=" + $('input[name=FilterType]:checked').val() + "&year=" + "@Model.Year" + "&startDate=" + $('#StartDate').val() + "&endDate=" + $('#EndDate').val(),
                        dataType: "json"
                    }
                },
                requestStart: function () {
                    if (initialLoad)
                        displayLoading(document.body, true);
                },
                requestEnd: function () {
                    if (initialLoad)
                        displayLoading(document.body, false);
                    initialLoad = false;

                },
                schema: {
                    total: "TotalCount",
                    data: "DataSource"
                },
                aggregate: [
                            { field: "AmountPaid", aggregate: "sum" }
                ],
                resizable: true,
            },
            excel: {
                allPages: true,
                fileName: "DependentCareReceiptReport.xlsx",
                proxyURL: "Save"
            },
            excelExport: function (e) {

                var rows = e.workbook.sheets[0].rows;

                @for (int i = ViewBag.Header.Count -1; i >= 0 ; i--)
                {
                    var item = ViewBag.Header[i];
                    <text>

                @*if(@ViewBag.PartnerFax != ""){
                    rows.unshift({
                        cells: [{ value: "fax:@ViewBag.PartnerFax" }]
                    });
                }*@
                rows.unshift({
                    cells: [{
                        value: ""
                    }]
                });

                if ("@item.Email" != "") {
                    rows.unshift({
                        cells: [{ value: "@item.Email" }]
                    });
                }

                if ("@item.Site" != "") {
                    rows.unshift({
                        cells: [{ value: "@item.Site" }]
                    });
                }

                if ("@item.Phone" != "") {
                    rows.unshift({
                        cells: [{ value: "@item.Phone" }]
                    });
                }

                if ("@item.Address" != "") {
                    rows.unshift({
                        cells: [{ value: "@item.Address" }]
                    });
                }

                @*if ("@ViewBag.PartnerP_O_Box" != "") {
                    rows.unshift({
                        cells: [{ value: "@ViewBag.PartnerP_O_Box" }]
                    });
                }*@

                if ("@item.Name" != "") {
                    rows.unshift({
                        cells: [{ value: "@item.Name" }]
                    });
                }


                for (var i = 0; i < rows.length; i++) {
                    for (var ci = 0; ci < rows[i].cells.length; ci++) {
                        rows[i].cells[ci].hAlign = "left";
                    }
                }

                    </text>
                }

                rows.unshift({
                    cells: [{ value: "Class meeting dates (@ViewBag.Date)" }]
                });

                rows.push({
                    cells: [{
                        value: ""
                    }]
                });

            },
            groupable: false,
            sortable: true,
            //scrollable: true,
            scrollable: {
                virtual: true
            },
            toolbar: [
                    { template: kendo.template($("#toolbarTemplate").html()) }
            ],
            pdf: {
                allPages: true,
                avoidLinks: true,
                date: new Date(),
                paperSize: "auto",
                margin: { top: "2cm", left: "1cm", right: "1cm", bottom: "1cm" },
                repeatHeaders: true,
                scale: 0.8,
                fileName: "DependentCareReceiptReport.PDF",
                template: $("#page-template").html(),
                proxyURL: "Save"

            },
            pdfExport: function (e) {
                //$("tr:nth-last-child(1)").hide();
                e.promise
                .progress(function (e) {
                    //console.log(kendo.format("{0:P} complete", e.progress));
                    e.progress;
                })
                .done(function () {
                    //$("tr:nth-last-child(1)").show();
                });
            },
            columns: [{
                field: "Date",
                title: "Payment date",
                width: "230px",
                //template: "#=kendo.toString(kendo.parseDate(Date), 'mm/dd/yyyy')#"
            },
            {
                field: "StudentName",
                title: "Student name",
                width: "230px"
            },
            {
                field: "ClassName",
                title: "Class name",
                width: "230px",
            },
            {
                field: "AmountPaid",
                title: "Amount paid ($)",
                width: "230px",
                footerTemplate: 'Total: #= kendo.toString(sum,"c2")#'
            },{
                field: "ScheduleDate",
                title: "Class date",
                width: "230px"

            },
            {
                field: "ClassMeetingDates",
                title: "Class meeting dates",
                width: "230px"
            },
            {
                field: "MethodOfPayment",
                title: "Method of payment",
                width: "230px",
                attributes: { style: "text-align:left" }
            },
            {
                field: "ProviderName",
                title: "Provider name",
                width: "230px"

            },
            {
                field: "ProviderTaxId",
                title: "Provider tax ID",
                width: "230px"

            }]

        });

        </text>
        }
     @for (int i = 0; i < ViewBag.Count; i++)
     {
         if (i == 0)
         {
             var item = ViewBag.Header[0];
          <text>
        $("#fsaReportGrid").append('<div style="padding:15px 20px"> ' + '@Html.Raw(item.Description.Replace("\n", "</br>"))' + ' </div>');
          </text>
             }
         }

     });

    $("#downloadExport").click(function (e) {

        e.preventDefault();

        if ($('#selectExport').find(":selected").text() == "PDF") {
            $("#fsaReportGrid").getKendoGrid().saveAsPDF();
        } else if ($('#selectExport').find(":selected").text() == "Excel") {
            $("#fsaReportGrid").getKendoGrid().saveAsExcel();
        }

    });


    $("#print").click(function (e) {
        e.preventDefault();
        printGrid();
    });

</script>


